importPath=string.gsub(getfenv(1)._.Name,"%.AnimationViewer","").."."
resourcePath=string.gsub(importPath,"%.","/").."Resources/"

if Settings==nil then Settings={} end
if Settings.TrimColor==nil then Settings.TrimColor=Turbine.UI.Color(.15,.15,.25) end

animationViewer=Turbine.UI.Window()
animationViewer:SetSize(displayWidth,displayHeight)
animationViewer:SetBackColor(Settings.TrimColor)

animationViewer:SetPosition(0,0)

animationViewer:SetZOrder(3) -- chapterMaint is ZOrder 2

animationViewer.ViewPort=Turbine.UI.ListBox()
animationViewer.ViewPort:SetParent(animationViewer)
animationViewer.ViewPort:SetMouseVisible(false)
animationViewer.ViewPort:SetPosition(1,1)
animationViewer.ViewPort:SetSize(displayWidth,displayHeight)
animationViewer.ViewPort:SetBackColor(Turbine.UI.Color.Black)

animationViewer.Canvas=Turbine.UI.Control()
animationViewer.Canvas:SetParent(animationViewer.ViewPort)
animationViewer.Canvas:SetMouseVisible(false)
animationViewer.ViewPort:AddItem(animationViewer.Canvas)

animationViewer.ViewPortVScroll=Turbine.UI.Lotro.ScrollBar()
animationViewer.ViewPortVScroll:SetParent(animationViewer)
animationViewer.ViewPortVScroll:SetOrientation(Turbine.UI.Orientation.Vertical)
animationViewer.ViewPortVScroll:SetSize(10,displayHeight-10)
animationViewer.ViewPortVScroll:SetPosition(displayWidth-10,10)
animationViewer.ViewPort:SetVerticalScrollBar(animationViewer.ViewPortVScroll)

animationViewer.ViewPortHScroll=Turbine.UI.Lotro.ScrollBar()
animationViewer.ViewPortHScroll:SetParent(animationViewer)
animationViewer.ViewPortHScroll:SetOrientation(Turbine.UI.Orientation.Horizontal)
animationViewer.ViewPortHScroll:SetSize(displayWidth-10,10)
animationViewer.ViewPortHScroll:SetPosition(0,displayHeight-10)
animationViewer.ViewPort:SetHorizontalScrollBar(animationViewer.ViewPortHScroll)

animationViewer.ShowMovie=function(moviePath,filePattern,frameCount,targetFPS,width,height,loop)
	local tmpSprites={}
	tmpSprites[1]={}
	for k=1,frameCount do
		tmpSprites[1][k]={}
		tmpSprites[1][k].Image=string.format(filePattern,k)
	end
	animationViewer.ShowAnimation(moviePath,nil,nil,tmpSprites,frameCount,targetFPS,width,height,loop)
end
animationViewer.ShowAnimation=function(animationPath,backImage,backColor,sprites,frameCount,targetFPS,width,height,loop)
	-- sprites is a table of sprites, each sprite containes one or more images keyed by frame number
	-- sprites[index][frame].Image
	-- sprites[index][frame].Top
	-- sprites[index][frame].Left
	-- sprites[index][frame].ZOrder
	-- viewer calculates the actual width and height here and also determines the overall required width/height
	if targetFPS==nil or tonumber(targetFPS)==nil then targetFPS=30 end
	targetFPS=tonumber(targetFPS)
	if targetFPS<1 then targetFPS=30 end
	if loop==nil then loop=false end
	animationViewer.Loop=loop
	animationViewer.FPS=targetFPS
	if frameCount==nil then frameCount=0 end
	animationViewer.FrameCount=frameCount
	local canvasWidth=width
	local canvasHeight=height
	if animationPath==nil then animationPath="" end
	if string.sub(animationPath,-1)~="/" then
		animationPath=animationPath.."/"
	end
	local tmpImage=Turbine.UI.Control()
	if backImage~=nil then
		if animationPath=="\\" and tonumber(backImage)~=nil and tonumber(backImage)>0 then
			animationViewer.BackGround=tonumber(backImage)
		else
			animationViewer.BackGround=animationPath..backImage
		end
		local success,result=pcall(Turbine.UI.Control.SetBackground,tmpImage,animationViewer.BackGround)
		if not success then
			animationViewer.BackGround=nil
		end
		tmpImage:SetStretchMode(2)
		canvasWidth,canvasHeight=tmpImage:GetSize()
	else
		animationViewer.BackGround=nil
	end
	if animationViewer.Sprites~=nil then
		-- clear out existing images
		for index,sprite in pairs(animationViewer.Sprites) do
			for index,sprite in pairs(animationViewer.Sprites) do
				if sprite.CurrentImage~=nil then
					-- release the previously displayed sprite graphic
					sprite.CurrentImage:SetVisible(false)
					sprite.CurrentImage:SetBackground(nil)
				end
				sprite.NextImage=nil -- release the preloaded graphic
			end
		end
	end
	animationViewer.Sprites=sprites
	if sprites~=nil and type(sprites)=="table" and frameCount>0 then
		local spriteCount=#sprites
		for index,sprite in ipairs(sprites) do
			-- preload the first image of each sprite
			animationViewer.Sprites[index].CurrentImage=Turbine.UI.Control() -- use controls since we just want an image
			animationViewer.Sprites[index].CurrentImage:SetPosition(0,0)
			animationViewer.Sprites[index].CurrentImage:SetVisible(false)
			animationViewer.Sprites[index].CurrentImage:SetParent(animationViewer.Canvas)
			animationViewer.Sprites[index].CurrentImage:SetMouseVisible(false)
			animationViewer.Sprites[index].CurrentImage:SetBlendMode(Turbine.UI.BlendMode.Overlay)
			for frame=1,frameCount do
				if sprite[frame]~=nil then
					local image=sprite[frame].Image

					if image~=nil then
						if animationPath=="\\" and tonumber(image)~=nil and tonumber(image)>0 then
							sprite[frame].Image=tonumber(image)
						else
							sprite[frame].Image=animationPath..tostring(image)
						end
					end
				end
			end
			if sprite[1]~=nil then
				if sprite[1].Image~=nil then
					-- preload the next image
					sprite.NextImage=Turbine.UI.Graphic(sprite[1].Image)
					if sprite.Width==nil or sprite.Height==nil then
						local tmpImage=Turbine.UI.Control()
						local success,result=pcall(Turbine.UI.Control.SetBackground,tmpImage,sprite.NextImage)
						tmpImage:SetStretchMode(2)
						sprite.Width,sprite.Height=tmpImage:GetSize()
						if canvasWidth==nil or sprite.Width>canvasWidth then canvasWidth=sprite.Width end
						if canvasHeight==nil or sprite.Height>canvasHeight then canvasHeight=sprite.Height end
					end
				end
			end
		end
	else
		animationViewer.Sprites={}
	end
	if canvasWidth==nil then canvasWidth=displayWidth end
	if canvasHeight==nil then canvasHeight=displayHeight end
	if width==nil then width=canvasWidth end
	if height==nil then height=canvasHeight end
	if width>displayWidth then width=displayWidth end
	if height>displayHeight then height=displayHeight end

	-- we are now ready to set up the viewer
	-- then load the image
	animationViewer.Canvas:SetBackground(animationViewer.BackGround)
	if backColor~=nil then
		animationViewer.Canvas:SetBackColor(backColor)
	else
		animationViewer.Canvas:SetBackColor(nil)
	end
	if canvasWidth< width-1 then
		-- no scrollbars, center viewer
		animationViewer.Canvas:SetWidth(canvasWidth)
		animationViewer.Canvas:SetLeft((width-canvasWidth)/2)
		animationViewer.ViewPort:SetWidth(width)
		animationViewer:SetWidth(width)
		animationViewer:SetLeft((displayWidth-width)/2-1)
		animationViewer.ViewPort:SetLeft(1)
	elseif canvasWidth<=width then
		-- no scrollbars, center viewer
		animationViewer.Canvas:SetWidth(canvasWidth)
		animationViewer.Canvas:SetLeft((width-canvasWidth)/2)
		animationViewer.ViewPort:SetWidth(width)
		animationViewer:SetWidth(width)
		animationViewer:SetLeft((displayWidth-width)/2)
		animationViewer.ViewPort:SetLeft(0)
	else
		-- need scrollbars, set canvas 10 pixels wider
		animationViewer.ViewPort:SetWidth(width)
		animationViewer.Canvas:SetWidth(canvasWidth+10)
		animationViewer:SetWidth(width)
		animationViewer:SetLeft((displayWidth-width)/2)
		animationViewer.ViewPort:SetLeft(0)
	end
	animationViewer.CloseButton:SetLeft(animationViewer:GetWidth()-16)
	if canvasHeight<= height-1 then
		-- no scrollbars, center image
		animationViewer.ViewPort:SetHeight(height)
		animationViewer.Canvas:SetHeight(canvasHeight)
		animationViewer.Canvas:SetTop((height-canvasHeight)/2)
		animationViewer:SetHeight(height+2)
		animationViewer:SetTop((displayHeight-height)/2-1)
		animationViewer.ViewPort:SetTop(1)
	elseif canvasHeight<= height then
		-- no scrollbars, center image
		animationViewer.ViewPort:SetHeight(height)
		animationViewer.Canvas:SetHeight(canvasHeight)
		animationViewer.Canvas:SetTop((height-canvasHeight)/2)
		animationViewer:SetHeight(height)
		animationViewer:SetTop((displayHeight-height)/2)
		animationViewer.ViewPort:SetTop(0)
	else
		-- need scrollbars, set canvas 10 pixels taller
		animationViewer.ViewPort:SetHeight(height)
		animationViewer.Canvas:SetHeight(canvasHeight+10)
		animationViewer:SetHeight(height)
		animationViewer:SetTop((displayHeight-height)/2)
		animationViewer.ViewPort:SetTop(0)
	end
	animationViewer.ViewPortVScroll:SetPosition(width-10,0)
	animationViewer.ViewPortVScroll:SetHeight(height-10)
	animationViewer.ViewPortHScroll:SetPosition(0,height-10)
	animationViewer.ViewPortHScroll:SetWidth(width-10)
	-- start Update
	animationViewer.Frame=1
	animationViewer.FrameTimeOut=Turbine.Engine:GetGameTime()+1/animationViewer.FPS
	animationViewer.PlayPosition:SetMinimum(1)
	animationViewer.PlayPosition:SetValue(1)
	animationViewer.PlayPosition:SetMaximum(animationViewer.FrameCount)
	-- force a garbage collection
	collectgarbage()
	animationViewer:SetWantsUpdates(true)
	animationViewer:SetVisible(true)
end
animationViewer.CloseButton=Turbine.UI.Control()
animationViewer.CloseButton:SetParent(animationViewer)
animationViewer.CloseButton:SetZOrder(1)
animationViewer.CloseButton:SetSize(16,16)
animationViewer.CloseButton:SetPosition(displayWidth-16,0)
animationViewer.CloseButton:SetBlendMode(Turbine.UI.BlendMode.Overlay)

animationViewer.GetFrameImage=function(sprite,frame)
	local image
	if sprite~=nil and frame~=nil and tonumber(frame)~=nil then
		frame=tonumber(frame)
		if frame>0 and frame<=animationViewer.FrameCount then
			if sprite[frame]~=nil then image=sprite[frame].Image end
			while image==nil and frame>0 do
				frame=frame-1
				if sprite[frame]~=nil then image=sprite[frame].Image end
			end
		end
	end
	return image
end

animationViewer.ControlPanel=Turbine.UI.Control()
animationViewer.ControlPanel:SetParent(animationViewer)
animationViewer.ControlPanel:SetVisible(false)
animationViewer.ControlPanel:SetZOrder(1) -- quarantee that the controlPanel is in front of other controls
animationViewer.ControlPanel:SetMouseVisible(false) -- the panel itself should not intercept mouse clicks, only it's child controls should
animationViewer.ControlPanel:SetHeight(47)
animationViewer.PlayPosition=Turbine.UI.Lotro.ScrollBar()
animationViewer.PlayPosition:SetParent(animationViewer.ControlPanel)
animationViewer.PlayPosition:SetHeight(10)
animationViewer.PlayPosition:SetPosition(10,0)
animationViewer.PlayPosition:SetOrientation(Turbine.UI.Orientation.Horizontal)
animationViewer.PlayPosition:SetBackColor(Turbine.UI.Color(.07,.14,.9))
animationViewer.PlayPosition.ValueChanged=function()
	if not animationViewer.Updating then
		animationViewer.ShowFrame(animationViewer.PlayPosition:GetValue())
	end
end
animationViewer.Rewind=Turbine.UI.Control()
animationViewer.Rewind:SetParent(animationViewer.ControlPanel)
animationViewer.Rewind:SetSize(32,32)
animationViewer.Rewind:SetTop(15)
animationViewer.Rewind:SetBlendMode(Turbine.UI.BlendMode.Overlay)
animationViewer.Rewind:SetBackground(resourcePath.."vcr_rewind.tga")
animationViewer.Rewind.MouseClick=function()
	if not animationViewer.Updating then
		local newFrame=animationViewer.Frame-animationViewer.FPS*10
		if newFrame<1 then newFrame=1 end
		animationViewer.ShowFrame(newFrame)
	end
end
animationViewer.Play=Turbine.UI.Control()
animationViewer.Play:SetParent(animationViewer.ControlPanel)
animationViewer.Play:SetSize(32,32)
animationViewer.Play:SetTop(15)
animationViewer.Play:SetBackground(resourcePath.."vcr_pause.tga")
animationViewer.Play:SetBlendMode(Turbine.UI.BlendMode.Overlay)
animationViewer.Play.MouseClick=function()
	-- pause/resume
	local paused=animationViewer:GetWantsUpdates()
	if paused then
		animationViewer.Play:SetBackground(resourcePath.."vcr_play.tga")
	else
		animationViewer.Play:SetBackground(resourcePath.."vcr_pause.tga")
		if animationViewer.Frame>=animationViewer.FrameCount then
			animationViewer.Frame=1
		end
		animationViewer.FrameTimeOut=Turbine.Engine:GetGameTime()
	end
	animationViewer:SetWantsUpdates(not paused)
end
animationViewer.ShowFrame=function(newFrame)
	if newFrame==nil then newFrame=1 end
	if newFrame>animationViewer.FrameCount then newFrame=animationViewer.FrameCount end
	if newFrame<1 then newFrame=1 end
	if animationViewer.Frame<newFrame then
		while animationViewer.Frame<newFrame do
			-- process all intervening frames just updating the position and image for each sprite
			for k,v in ipairs(animationViewer.Sprites) do
				if v[animationViewer.Frame]~=nil then
					v.TempVisible=true
					if v[animationViewer.Frame].Left~=nil then
						v.TempLeft=v[animationViewer.Frame].Left
					end
					if v[animationViewer.Frame].Top~=nil then
						v.TempTop=v[animationViewer.Frame].Top
					end
					if v[animationViewer.Frame].ZOrder~=nil then
						v.TempZOrder=v[animationViewer.Frame].ZOrder
					end
					if v[animationViewer.Frame].Image~=nil then
						v.TempImage=v[animationViewer.Frame].Image
					end
				else
					v.TempVisible=false
				end
			end
			animationViewer.Frame=animationViewer.Frame+1
		end
	elseif animationViewer.Frame>newFrame then
		-- need to go backward until we have temp values for Top, Left, ZOrder and Image for ALL sprites
		for k,v in ipairs(animationViewer.Sprites) do
			v.OK=false
		end
		local tmpFrame=animationViewer.Frame
		for tmpFrame=newFrame,1,-1 do
			local isOK=true
			for k,v in ipairs(animationViewer.Sprites) do
				if not v.OK then
					local spriteOK=true
					-- check for top, left, zorder and image at this frame
					if v.TempTop==nil then
						if v[tmpFrame].Top~=nil then
							v.TempTop=v[tmpFrame].Top
						else
							spriteOK=false
						end
					end
					if v.TempLeft==nil then
						if v[tmpFrame].Left~=nil then
							v.TempLeft=v[tmpFrame].Left
						else
							spriteOK=false
						end
					end
					if v.TempZOrder==nil then
						if v[tmpFrame].ZOrder~=nil then
							v.TempZOrder=v[tmpFrame].ZOrder
						else
							spriteOK=false
						end
					end
					if v.TempImage==nil then
						if v[tmpFrame].Image~=nil then
							v.TempImage=v[tmpFrame].Image
						else
							spriteOK=false
						end
					end
					v.OK=spriteOK
				end
				isOK=v.OK and isOK
			end
			if isOK then break end
		end
	end
	-- now apply any temp values
	for k,v in ipairs(animationViewer.Sprites) do
		if v.TempLeft~=nil then
			v.CurrentImage:SetLeft(v.TempLeft)
			v.TempLeft=nil
		end
		if v.TempTop~=nil then
			v.CurrentImage:SetTop(v.TempTop)
			v.TempTop=nil
		end
		if v.TempZOrder~=nil then
			v.CurrentImage:SetZOrder(v.TempZOrder)
			v.TempZOrder=nil
		end
		if v.TempVisible~=nil then
			v.CurrentImage:SetVisible(v.TempVisible)
			v.TempVisible=nil
		end
		if v.TempImage~=nil then
			v.CurrentImage:SetBackground(v.TempImage)
			v.TempImage=nil
		end
		if v[newFrame].Image~=nil then
			v.NextImage=Turbine.UI.Graphic(v[newFrame].Image)
			if v.Width==nil or v.Height==nil then
				local tmpImage=Turbine.UI.Control()
				pcall(Turbine.UI.Control.SetBackground,tmpImage,v.NextImage)
				tmpImage:SetStretchMode(2)
				v.Width,v.Height=tmpImage:GetSize()
			end
		else
			v.NextImage=nil
		end
	end
	animationViewer.Updating=true
	animationViewer.Frame=newFrame
	animationViewer.PlayPosition:SetValue(newFrame)
	animationViewer.Updating=false
	animationViewer.FrameTimeOut=Turbine.Engine:GetGameTime()
	animationViewer.Update() -- force one proper update
end

animationViewer.Forward=Turbine.UI.Control()
animationViewer.Forward:SetParent(animationViewer.ControlPanel)
animationViewer.Forward:SetSize(32,32)
animationViewer.Forward:SetTop(15)
animationViewer.Forward:SetBlendMode(Turbine.UI.BlendMode.Overlay)
animationViewer.Forward:SetBackground(resourcePath.."vcr_forward.tga")
animationViewer.Forward.MouseClick=function()
	if not animationViewer.Updating then
		local newFrame=animationViewer.Frame+animationViewer.FPS*30
		animationViewer.ShowFrame(newFrame)
	end
end

animationViewer.MouseClick=function()
	animationViewer.Play.MouseClick()
end
animationViewer.MouseMove=function()
	animationViewer.ControlPanel:SetVisible(true)
end
animationViewer.MouseHover=function()
	animationViewer.ControlPanel:SetVisible(false)
end

animationViewer.CloseButton.MouseClick=function()
	animationViewer:SetVisible(false)
	animationViewer:SetWantsUpdates(false)
end
if localPlayer:GetAlignment()==2 then
	animationViewer.CloseButton:SetBackground(0x41005f41)
else
	animationViewer.CloseButton:SetBackground(0x41000196)
end


animationViewer.Closed=function()
	animationViewer:SetWantsUpdates(false)
end
animationViewer.Update=function()
	animationViewer.Updating=true
-- use CurrentFrame to clear the prior frame, then set CurrentFrame to NextFrame and display, then set NextFrame to a new frame and preload all of the images for that frame
	local timeNow=Turbine.Engine:GetGameTime()
	local catchUp=0 -- limit "catch up" to 1 second to prevent endless loops
	if timeNow>=animationViewer.FrameTimeOut then
		while timeNow>=animationViewer.FrameTimeOut and catchUp<animationViewer.FPS do
			catchUp=catchUp+1
			-- clear the prior frame
			for k,v in ipairs(animationViewer.Sprites) do
				if v.CurrentImage~=nil then
					v.CurrentImage:SetVisible(false)
					v.CurrentImage:SetBackground(nil)
				end
			end
			-- advance frames until we reach the current time (this allows dropping frames in case the client is running slower than the desired FPS)
			animationViewer.FrameTimeOut=animationViewer.FrameTimeOut+1/animationViewer.FPS
			-- update the frame
			for k,v in ipairs(animationViewer.Sprites) do
				if v[animationViewer.Frame]~=nil then
					v.CurrentImage:SetVisible(true)
					if v[animationViewer.Frame].Left~=nil then
						v.CurrentImage:SetLeft(v[animationViewer.Frame].Left)
					end
					if v[animationViewer.Frame].Top~=nil then
						v.CurrentImage:SetTop(v[animationViewer.Frame].Top)
					end
					if v[animationViewer.Frame].ZOrder~=nil then
						v.CurrentImage:SetZOrder(v[animationViewer.Frame].ZOrder)
					end
					if v.NextImage~=nil then
						v.CurrentImage:SetBackground(v.NextImage)
						v.CurrentImage:SetSize(v.Width,v.Height)
					end
				else
					v.CurrentImage:SetVisible(false)
				end
			end
			if animationViewer.Frame<animationViewer.FrameCount then
				animationViewer.Frame=animationViewer.Frame+1
			else
				-- force a garbage collection on each loop, trying to minimize memory usage - the lotro client still caches some stuff we can't clean up but every bit helps
				collectgarbage()
				if animationViewer.Loop then
					animationViewer.Frame=1
				else
					animationViewer.Frame=animationViewer.FrameCount -- prevent any accidental out of bounds
					animationViewer:SetWantsUpdates(false)
					animationViewer.Play:SetBackground(resourcePath.."vcr_play.tga")
				end
			end
			animationViewer.PlayPosition:SetValue(animationViewer.Frame)
			for k,v in ipairs(animationViewer.Sprites) do
				if v[animationViewer.Frame].Image~=nil then
					v.NextImage=Turbine.UI.Graphic(v[animationViewer.Frame].Image)
					if v.Width==nil or v.Height==nil then
						local tmpImage=Turbine.UI.Control()
						pcall(Turbine.UI.Control.SetBackground,tmpImage,v.NextImage)
						tmpImage:SetStretchMode(2)
						v.Width,v.Height=tmpImage:GetSize()
					end
				else
					v.NextImage=nil
				end
			end
		end
	end
	animationViewer.Updating=false
end
animationViewer.SizeChanged=function()
	local width,height=animationViewer:GetSize()
	animationViewer.ControlPanel:SetWidth(width)
	animationViewer.ControlPanel:SetTop(height-60)
	animationViewer.PlayPosition:SetWidth(width-20)
	animationViewer.Rewind:SetLeft(width/2-58)
	animationViewer.Play:SetLeft(width/2-16)
	animationViewer.Forward:SetLeft(width/2+26)
end